
//============================================================
//                                                          ==
//     FILE:      dverk.h                                   ==
//                                                          ==
//============================================================

#ifndef DVERK_H
#define DVERK_H
class DVERKCTRL{
  public:
    int      nErrThumb           ; //   C[1]  ; 0 || 1 || ... || 6
    double   dErrFloor           ; //   C[2]  ;
    double   dStepMin            ; //   C[3]  ;
    double   dStepStart          ; //   C[4]  ;
    double   dScale              ; //   C[5]  ;
    double   dStepMax            ; //   C[6]  ;
    long int lMaxFuncCalls       ; //   C[7]  ;
    int      nInterrupt1         ; //   C[8]  ; 0 || 1
    int      nInterrupt2         ; //   C[9]  ; 0 || 1
     double   dRelRoundErrBound   ; //   C[10] ;
     double   dDwarf              ; //   C[11] ;
     double   dWeightedNorm       ; //   C[12] ;
     double   dHMINInner          ; //   C[13] ;
     double   dStepMagn           ; //   C[14] ;
     double   dScaleInner         ; //   C[15] ;
     double   dHMAXInner          ; //   C[16] ;
     double   dXTrial             ; //   C[17] ;
     double   dStepTrial          ; //   C[18] ;
     double   dEstimation         ; //   C[19] ;
     double   dPrevXEND           ; //   C[20] ;
     int      nFlagXEND           ; //   C[21] ;
     long int lSuccSteps          ; //   C[22] ;
     long int lSuccFails          ; //   C[23] ;
     long int lFuncCounter        ; //   C[24] ;
     DVERKCTRL();
};

//  DVERKCTRL;
typedef int ODEFUNC(int N, double X, double* Y, double* YPRIME);
int dverk(
     int         N       // int        N ;
   , ODEFUNC     FCN     // ODEFUNC    FCN ;
   , double    * X       // double   * X - (INPUT AND OUTPUT);
   , double    * Y       // double   * Y ;
   , double      XEND    // double     XEND (INPUT) ;
   , double      TOL     // double     TOL - ERROR CONTROL. (INPUT) ;
   , int       * IND     // int      * IND - INDICATOR. (INPUT AND OUTPUT).
   , DVERKCTRL * CCC     // DVERKCTRL* CCC (INPUT IF *IND != 1, AND OUTPUT).
   , double    * YFLOOR  // double   * YFLOOR ( N ).
   , double    * W       // double   * W [ N * 9 ].
    );
#endif

//==========================================================
//                                                          
//  ENDFILE:      dverk.h                                   
//                                                          
//==========================================================

